/**
 * A simple bank account. This class implements a simple bank account. A bank
 * account has two components, the name and the amount.
 * 
 * @author Franz Hacker
 * @version 1.1
 */
public class BankAccount {
	/** Counter for bank accounts. */
	private static int bankAccountCounter = 0;
	/** Name of the holder. */
	private String name;
	/** Amount stored in the bank account. */
	private double amount;

	/**
	 * Custom constructor accepting values for name and initial amount.
	 * 
	 * @param name
	 *            the name of the account holder.
	 * @param amount
	 *            the initial amount.
	 */
	public BankAccount(final String name, final double amount) {
		this.name = name;
		this.amount = amount;
		BankAccount.bankAccountCounter++;
	}

	/**
	 * Increases the amount of the account.
	 * 
	 * @param amount
	 *            the amount to be added. If the amount is negative the stored
	 *            amount remains unchanged.
	 * @return a boolean value that reports the success of the operation
	 */

	public boolean depositAmount(final double amount) {
		final boolean ok = (this.amount >= 0.0);
		if (ok) {
		   this.amount -= amount;
		}
		return ok;
    }
}
