public class ArrayStack implements Stack {
  
    private final Object[] data;
    private int position = 0;
    
    private final static int DEFAULT_SIZE = 100;

    public ArrayStack() {
        this(DEFAULT_SIZE);
    }
    
    public ArrayStack(int size) {
        this.data = new String[size];
    }
    
    public void push(Object o) throws StackFullException {
        if (this.position < this.data.length) {
            this.data[this.position] = o;
            this.position++;
        } else {
            throw new StackFullException("stack size of " + this.data.length + " exceeded");
        }
    }
    
    public int size() {
        return this.position;
    }
    
    public Object pop() throws StackEmptyException {
        if (this.position > 0) {            
            this.position--;
            Object o = this.data[this.position];
            this.data[this.position] = null;
            return o;
        } else {
            throw new StackEmptyException();
        }
    }
           
}