import java.io.*;
public class FinallyTest {

    // returns null, if any problem occurred
    public static String readFile(String fileName) {
        String s = null;
        Reader r = null;
        try {
            r = new FileReader (fileName);
            StringBuilder sb = new StringBuilder();
            int c = r.read();
            while (c != -1) {
                sb.append((char) c);
                c = r.read();
            }
            s = sb.toString();
        } catch (FileNotFoundException e) {
            System.err.println("Could not open file "+fileName);
        } catch (IOException e) {
            System.err.println("Problem occured while reading file");
            e.printStackTrace();
        } finally {
            System.out.println("in finally");
            if (r != null) {
                System.out.println("Closing file");
                try {
                    r.close();
                } catch (IOException e) {                    
                    System.err.println("Problem occured while closing file");
                    e.printStackTrace();
                }
            }
        }
        return s;
    }
    
    public static void main(String[] args) {
        System.out.println(readFile(args[0]));
    }
}
