package gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

class BadTextField extends JTextField {
    public BadTextField(int size) {
	super(size);
    }

    public void paint(Graphics g) {
	if (!this.getText().equals("")) {
	    this.setBorder(BorderFactory.createLineBorder(Color.RED));
	}
	super.paint(g);
    }
}

public class BadDemo {
    
    private static void createAndShowGUI() {
	final JTextField tf = new BadTextField(20);
	Button b = new Button("Click Me");
	b.addActionListener(new ActionListener() {
	    int numClicks = 0;

	    public void actionPerformed(ActionEvent e) {
		this.numClicks++;
		tf.setText(this.numClicks + " clicks");
	    }

	});
	JFrame frame = new JFrame("Click Test");
	frame.getContentPane().add(b, BorderLayout.LINE_START);
	frame.getContentPane().add(tf, BorderLayout.CENTER);
	frame.pack();
	frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	frame.setVisible(true);
    }

    public static void main(String[] args) {
	javax.swing.SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
		createAndShowGUI();
	    }
	});
    }        

}
