public class Cartesian implements Complex {
    
    private final double real;
    private final double imag;
    
    public Cartesian(double real, double imag) {
        this.real = real;
        this.imag = imag;
    }
    
    public double getReal() {
        return this.real;
    }
    
    public double getImag() {
        return this.imag;
    }
    
    public double getDistance() {
        return Math.sqrt(this.real * this.real 
          + this.imag * this.imag);
    }
    
    public double getPhase() {
        return Math.atan2(this.imag, this.real);
    }
    
    public Complex multiply(Complex other) {
        return new Cartesian(
          this.real * other.getReal() - this.imag * other.getImag(),
          this.real * other.getImag() + this.imag * other.getReal());
    }
    
    public Complex add(Complex other) {
        return new Cartesian(
          this.real + other.getReal(),
          this.imag + other.getImag());
    }
        
}
