public class ColoredCircle3 extends Circle3 {
    public static final int RED = 1, BLUE = 2;
    
    private int color;
    
    public ColoredCircle3(double radius, int color) {
        super(radius);
        this.color = color;
    }
    
    public boolean equals(Object obj) {
        if (obj instanceof ColoredCircle3) {
            ColoredCircle3 other = (ColoredCircle3) obj;
            return super.equals(other) && this.color == other.color;
        } else {
            return super.equals(obj);
        }
    }
    
    public static void testSymmetry() {
        Circle3 c1 = new Circle3(2.5);
        Circle3 c2 = new ColoredCircle3(2.5, RED);        
        System.out.println(c1.equals(c2));
        System.out.println(c2.equals(c1));
    }

    public static void testTransitivity() {
        Circle3 c1 = new ColoredCircle3(2.5, RED);        
        Circle3 c2 = new Circle3(2.5);
        Circle3 c3 = new ColoredCircle3(2.5, BLUE);        
        System.out.println(c1.equals(c2));
        System.out.println(c2.equals(c3));
        System.out.println(c1.equals(c3));
    }

}
