public class ColoredCircle4 extends Circle4 {
    public static final int RED = 1, BLUE = 2;
    
    private int color;
    
    public ColoredCircle4(double radius, int color) {
        super(radius);
        this.color = color;
    }
    
    public boolean equals(Object obj) {
        if (this.getClass() == obj.getClass()) {
            ColoredCircle4 other = (ColoredCircle4) obj;
            return super.equals(other) && this.color == other.color;
        } else {
            return super.equals(obj);
        }
    }
    
    public static void testSymmetry() {
        Circle4 c1 = new Circle4(2.5);
        Circle4 c2 = new ColoredCircle4(2.5, RED);        
        System.out.println(c1.equals(c2));
        System.out.println(c2.equals(c1));
    }

    public static void testTransitivity() {
        Circle4 c1 = new ColoredCircle4(2.5, RED);        
        Circle4 c2 = new Circle4(2.5);
        Circle4 c3 = new ColoredCircle4(2.5, BLUE);        
        System.out.println(c1.equals(c2));
        System.out.println(c2.equals(c3));
        System.out.println(c1.equals(c3));
    }

    public int hashCode() {
        return 31 * super.hashCode() + this.color;
    }
}
