public class ColoredCircle5 extends Circle5 {
    public static final int RED = 1, BLUE = 2;
    
    private int color;
    
    public ColoredCircle5(double radius, int color) {
        super(radius);
        this.color = color;
    }

    // not allowed to overwrite equals
    
    public static void testSymmetry() {
        Circle5 c1 = new Circle5(2.5);
        Circle5 c2 = new ColoredCircle5(2.5, RED);        
        System.out.println(c1.equals(c2));
        System.out.println(c2.equals(c1));
    }

    public static void testTransitivity() {
        Circle5 c1 = new ColoredCircle5(2.5, RED);        
        Circle5 c2 = new Circle5(2.5);
        Circle5 c3 = new ColoredCircle5(2.5, BLUE);        
        System.out.println(c1.equals(c2));
        System.out.println(c2.equals(c3));
        System.out.println(c1.equals(c3));
    }

    public static void testInstanceof() {
        Circle5 c1 = new ColoredCircle5(2.5, RED);
        Circle5 c2 = new Circle5(2.5);
        System.out.println(c1.equals(c2));
        System.out.println(c1 instanceof ColoredCircle5);
        System.out.println(c2 instanceof ColoredCircle5);
    }
    
    // no implementation of hashCode, since we do not overwrite equals
}