public class Polar implements Complex {
    
    private final double dist;
    private final double phase;
    
    public Polar(double dist, double phase) {
        this.dist = dist;
        this.phase = phase;
    }
    
    public double getReal() {
        return this.dist * Math.cos(this.phase);
    }
    
    public double getImag() {
        return this.dist * Math.sin(this.phase);
    }
    
    public double getDistance() {
        return dist;
    }
    
    public double getPhase() {
        return phase;
    }
    
    public Complex multiply(Complex other) {
        return new Polar(
          this.dist * other.getDistance(),
          this.phase + other.getPhase());
    }
    
    public Complex add(Complex other) {        
        return new Cartesian(
          this.getReal() + other.getReal(),
          this.getImag() + other.getImag());
    }

}