public class StackContainerTest {
    
    public static void main(String[] args) {
        
        // use as stack
        Stack s = new ArrayStack();
        s.push("foo"); s.push("bar");
        while (s.size() > 0) {
            System.out.println(s.pop());
        }
        
        // use as container
        Container c = new ArrayStack();
        c.addElement("foo"); c.addElement("bar");
        Iterator i = c.iterator();
        while (i.hasNext()) {
            System.out.println(i.next());
        }
        System.out.println(c.size());
        
        // not possible due to static type
        // i = s.iterator();
        // c.push("string");
        
        // now use LinkedList as Container
        LinkedList list = new LinkedList();
        c = list;
        c.addElement("foo"); c.addElement("bar");
        i = c.iterator();
        while (i.hasNext()) {
            System.out.println(i.next());
        }
        System.out.println(c.size());
        // i.remove(); not possible due to static type

        // the removable iterator only available from list
        RemovableIterator ri = list.iterator();
        while (ri.hasNext()) {
            System.out.println(ri.next());
        }
        ri.remove();
        System.out.println(list.size());
        
        ri = list.iterator();
        while (ri.hasNext()) {
            System.out.println(ri.next());
        }
        ri.remove();
        System.out.println(list.size());

    }
}
