public class Teacher extends Person {
    private Person[] students = null;
    
    public Teacher(String name, Address address) {
        super(name, address);
    }
    
    public void setStudents(Person[] students) {
        this.students = students;
    }
    
    public String toString() {
        return "Teacher: " + super.toString();
    }
    
    public Teacher clone() throws CloneNotSupportedException {
        Teacher t = (Teacher)super.clone();
        // after shallow copy clone mutable member variables
        if (t.students != null) {
            t.students = t.students.clone(); // shallow copy of array
            for (int i = 0; i < t.students.length; i++) {
                t.students[i] = t.students[i].clone();
            }
        }
        return t;
    }    
}