package junit;

import java.util.*;

public class ArrayStack<T> implements Stack<T> {

    private T[] data;
    private int pos = 0;
    private static final int DEFAULT_SIZE = 100;

    public ArrayStack(int size) {
	this.data = (T[]) new Object[size];
    }

    public ArrayStack() {
	this(DEFAULT_SIZE);
    }

    public boolean isEmpty() {
	return this.pos == 0;
    }

    public T pop() {
	if (this.isEmpty()) {
	    throw new EmptyStackException();
	}
	this.pos--;
	T elem = this.data[this.pos];
	this.data[this.pos] = null;
	return elem;
    }

    public void push(T t) {
	this.data[this.pos] = t;
	this.pos++;
    }

    public int size() {
	return this.pos;
    }

}
