package junit;
import static org.junit.Assert.*;

import java.util.*;

import org.junit.*;

public class StackTest {

    Stack<String> empty;
    Stack<String> fbc;

    @Before
    public void setUp() {
	this.empty = new ArrayStack<>();
	this.fbc = new ArrayStack<>();
	this.fbc.push("foo");
	this.fbc.push("bar");
	this.fbc.push("com");
    }

    @Test
    public void size0Test() {
	assertEquals(0, this.empty.size());
    }

    @Test
    public void empty0Test() {
	assertTrue(this.empty.isEmpty());
    }

    @Test(expected = EmptyStackException.class)
    public void popEmptyTest() {
	assertEquals("dummy", this.empty.pop());
    }

    @Test
    public void emptyFBCTest() {
	assertFalse(this.fbc.isEmpty());
    }

    @Test
    public void sizeFBCTest() {
	assertEquals(3, this.fbc.size());
    }

    @Test(timeout = 1000)
    public void clearTest() {
	while (!this.fbc.isEmpty()) {
	    this.fbc.pop();
	}
	assertEquals(0, this.fbc.size());
    }

    @Test
    public void comTest() {
	assertEquals("com", this.fbc.pop());
    }

    @Test
    public void barTest() {
	this.fbc.pop();
	assertEquals("bar", this.fbc.pop());
    }

}
