public class Course {
    
    private String name;
    private Person leader;
    private Person[] participants;
    private int nrParticipants;
    
    public Course(String name, Person leader, int capacity) {
        this.name = name;
        this.leader = leader;
        this.participants = new Person[capacity];
        this.nrParticipants = 0;
    }
    
    public boolean register(Person p) {
        if (this.nrParticipants < this.participants.length) {
            this.participants[this.nrParticipants] = p;
            this.nrParticipants++;
            return true;
        } else {
            return false;
        }
    }
    
    public String[] getPhoneNumbers() {
        String[] numbers = new String[this.nrParticipants];
        int count = 0;
        for (int i=0; i < this.nrParticipants; i++) {
            Person p = this.participants[i];
            Address a = p.getAddress();
            String number = a.getPhoneNumber();
            if (number != null) {
                numbers[count] = number;
                count++;
            } else {
                System.err.println("Warning, participant " + p.toString() + " has no phone number");
            }
        }        
        return java.util.Arrays.copyOf(numbers,count);
    }
}