public class Rational2 {
  private long n; // numerator
  private long d; // denominator
  
  public Rational2(long n, long d) {
      if (d == 0) 
          System.err.println("division by zero");
      this.d = d;
      this.n = n;
      normalize();
  }
    
  public Rational2(long integer) {
      this(integer, 1);
  }
  
  private void normalize() {
      if (this.d < 0) {
          this.d = -this.d;
          this.n = -this.n;
      }
      long gcd = gcd(Math.abs(this.n), this.d);
      this.n /= gcd;
      this.d /= gcd;
  }
  
  public String toString() {
      return (this.n + "/" + this.d);
  }
  
  public Rational2 multiply(Rational2 other) {
      return new Rational2(
          this.n * other.n,
          this.d * other.d);
  }
  
  public Rational2 add(Rational2 other) {
      return new Rational2(
          this.n * other.d + this.d * other.n,
          this.d * other.d);
  }

  public Rational2 negate(Rational2 other) {
      return new Rational2( -this.n, this.d);
  }

  private static long gcd(long x, long y) {
        return y==0 ? x : gcd(y, x % y); 
  }

}
